# Extended reading

Based on the previous practice, you have a further understanding of some key concepts and concepts of CYFS. In this chapter we will try to explore these concepts and ideas a little bit. Much of the content of this chapter comes directly from "CYFS White Paper" and "CYFS White Paper Interpretation", but unfortunately we are still in the internal review stage of these two tomes, so this chapter has not yet been completed. But in line with the principle of "completion is more important than perfection", we still put the chapter in writing first.

# go to the center

In a system with many nodes distributed, each node is characterized by a high degree of autonomy. Nodes can be freely connected to each other to form new connection units. Any node may become a phased center, but it does not have a mandatory center control function. The influence between nodes will form a nonlinear causal relationship through the network. We call this open, flat, and egalitarian system phenomenon or structure decentralization.

# trusted data

Trusted data refers to verifiable, non-tamperable and non-repudiation data signed by the user's private key and stored in the blockchain. These data are stored in a distributed manner in a decentralized manner.

# Semantic data

In essence, data is a symbol, which has no meaning in itself. Only data that has been given meaning can be used. At this time, the data is converted into semantic data.
Semantic data can be simply regarded as the meaning of the concepts represented by the things in the real world corresponding to the data, and the relationship between these meanings, which is the interpretation and logical representation of the data in a certain field.

# data naming

# Data property rights

The owner or user of the device has the right to benefit or damage the property interests of himself or others through the network data generated based on the data behavior. As the object of data property rights, data is the foundation of the data property rights system. The subject of interest is not limited to natural persons, but also includes legal persons, unincorporated organizations, governments or countries.

## Characteristics of data property rights

1. Data property rights take information as its content
   Information is the content of data, and data is the form of information. Information is generated, transmitted and stored in the form of data, and the control data has the relevant information. In this sense, data and information have natural symbiosis and consistency.

2. Data property rights have the attribute of economic interests
   The core value of data property rights is that it has economic benefits. In the data age, data is related to economic activities. Data activities will bring certain economic value, and the commercial value and social value of data are increasing, and it is an indisputable fact that it has economic benefits. Because of this, data itself is not an object, but the economic benefits generated by data-based activities have objectivity and become the object of property rights.

3. Data property rights are exclusive to specific subjects
   Where there is interest, there must be attribution. As a kind of right, data property rights must belong to a certain subject, which has the controllability and exclusivity. For the right holder, it can be exclusively possessed, dominated and used.

4. Data property rights have the value of production factors
   The traditional theory holds that the factors of production mainly include labor, land and capital. Whether a thing is a factor of production, the main criterion is whether it is necessary for material production. After human beings entered the Internet era, the role of various types of data in production and business activities has become increasingly prominent, and has become an irreplaceable factor of production. Data is not only the core element of the new economy, but also changes the production methods and business models of traditional industries.

## Classification of data property rights

1. Data Assets
   Data assets are based on historically formed and have a relatively clear business value and scope of operation. The boundaries of the assets are relatively clear, and the total amount of data is also clear. Such data assets can have relatively stable market demand and clear price judgment criteria for a long period of time. For example, within the scope of data that can be configured in the market, a certain industry authority of the government gathers all the visualized data information of this industry in the whole country or a certain region in a historical period according to certain standards.

2. Data Rights
   Data rights and interests are based on dynamically changing data property rights and all expected benefits that may be brought in the future. The market value of data rights and interests is based on future judgments on data trends and the ability to summarize and analyze data platforms, and even technological changes must be considered. inside. The boundaries of the quantity, scope and benefits of data rights are uncertain, but the time boundary and ownership boundary of data rights are clear. Data rights are more like the financing behavior of data assets. For investors of data rights, this may produce a greater asset appreciation effect and an opportunity to gain market competitive advantages. For example, the right to use data on the supply or demand changes of a certain type of commodity on an e-commerce trading platform in the future. Since data differences of different platforms, different standards, different frequencies, and different time periods will bring changes to investors' future returns, investors gain more possibilities for analysis and application while obtaining data rights.

3. Data Products
   The scope of data products can be said to be infinite. Data products emphasize the timeliness or immediacy of data. There is one biggest difference between data products and data assets and rights. Data products are personalized designs that lead products from the demand side. Real-time connection between demand and supply can be realized to meet the production and operation needs of data product demanders at any time. For example, the real-time data of a certain company's market share of various companies in the industry in the current month; the real-time market feedback data of a company after launching a new product; customer data, etc.
