# 数据交换合约

CYFS 提出了数据交换合约方案，进一步扩展了可信计算的边界。让可信计算不必全部运行在区块链上。数据交换合约理论依赖的数据产权理论，完整的描述了人类的可信信息的演变过程，并把这个过程称作有权数据网，CYFS。作为 Web3.0 的定义。在这个新的理论指导下，我们能让普通人日常使用的传统 Web2.0 应用变得可信与去中心化。本文将详细阐述有权数据网（CYFS 计算网络）的设计思路和运行原理。
在 CYFS 中，数据交换合约的可信运行，并不依赖区块链技术，可以成为链下可信计算的基础组件。

# DAO

## 什么是 DAO

DAO 是英文 Decentralized Autonomous Organization 的缩写，是基于区块链核心思想理念（由达成同一个共识的群体自发产生的共创、共建、共治、共享的协同行为）衍生出来的一种组织形态。是区块链解决了人与人之间的信任问题之后的附属产物。
DAO 是公司这一组织形态的进化版，是人类协作史上的一次革命性的进化。其本质是区块链技术应用的一种形式。

## DAO 的 3 个基本要素

一个 DAO 必须具备三个基本要素：
1、具有能与陌生人达成共识的组织目标和组织文化（组织的使命、愿景、价值观）。
2、具有能与陌生人达成共识的包含创立、治理、激励等内容的规则体系，且此规则通过区块链技术置于链上。
3、具有能与所有参与者形成利益关联的 Token 来实现全员激励。

## DAO 有哪些特征

DAO 是一种将组织的管理和运营规则以智能合约的形式编码在区块链上，从而在没有集中控制或第三方干预的情况下自主运行的组织形式。
DAO 有望成为应对不确定、多样、复杂环境的一种新型有效组织。
DAO 具有充分开放、自主交互、去中心化控制、复杂多样以及涌现等特点。与传统的组织现象不同，DAO 不受现实物理世界的空间限制，其演化过程由事件或目标驱动，快速形成、传播且高度互动，并伴随着目标的消失而自动解散。
DAO 具备如下特征：

1. 分布式与去中心化（distributed and decentralized）
   DAO 中不存在中心节点以及层级化的管理架构[30]，它通过自下而上的网络节点之间的交互、竞争与协作来实现组织目标。因此，DAO 中节点与节点之间、节点与组织之间的业务往来不再由行政隶属关系所决定，而是遵循平等、自愿、互惠、互利的原则，由彼此的资源禀赋、互补优势和利益共赢所驱动。每个组织节点都将根据自己的资源优势和才能资质，在通证的激励机制的作用下有效协作，从而产生强大的协同效应。
2. 自主性与自动化（autonomous and automated）
   在一个理想状态的 DAO 中，管理是代码化、程序化且自动化的。“代码即法律”（code is law），组织不再是金字塔式而是分布式，权力不再是中心化而是去中心化，管理不再是科层制而是社区自治，组织运行不再需要公司而是由高度自治的社区所替代。此外，由于 DAO 运行在由利益相关者共同确定的运行标准和协作模式下，组织内部的共识和信任更易达成， 可以最大限度地降低组织的信任成本、沟通成本和交易成本。
3. 组织化与有序性（organized and ordered）
   依赖于智能合约，DAO 中的运转规则、参与者的职责权利以及奖惩机制等均公开透明。此外，通过一系列高效的自治原则，相关参与者的权益得到精准分化与降维，即给那些付出劳动、做出贡献、承担责任的个体匹配相应的权利和收益，以促进产业分工以及权利、责任、利益均等，使得组织运转更加协调、有序。
4. 智能化与通证化 （intelligence and tokenization）
   DAO 底层以封装了支持 DAO 及其衍生应用的所有基础设施——互联网基础协议、区块链技术、人工智能、大数据、物联网等为技术支撑，以数字化、智能化、链上链下协同治理为治理手段，改变了传统的科层制以及人为式管理方式，实现了组织的智能化管理。通证（token）作为 DAO 治理过程中的重要激励手段，将组织中的各个元素（例如人、组织、知识、事件、产品等）数字化、通证化，从而使得货币资本、人力资本以及其他要素资本充分融合，更好地激发组织的效能和实现价值流转。
